--Lens Flare #2 effect filter by khaver

obs = obslua

SETTING_HAIR = 'hair'
SETTING_CENTERX = 'centerx'
SETTING_CENTERY = 'centery'
SETTING_AMOUNT = 'amount'
SETTING_COMPLEX = 'complex'
SETTING_ZOOM = 'zoom'
SETTING_SCATTER = 'scatter'
SETTING_AFFECT = 'affect'
SETTING_THRESH = 'thresh'
SETTING_DIST = 'dist'

TEXT_HAIR = 'Show Target'
TEXT_CENTERX = 'Center X'
TEXT_CENTERY = 'Center Y'
TEXT_AMOUNT = 'Intensity'
TEXT_COMPLEX = 'Lens Adjustment'
TEXT_ZOOM = 'Flare Size'
TEXT_SCATTER = 'Light Scatter'
TEXT_AFFECT = 'Use Image Intensity'
TEXT_THRESH = 'Threshold'
TEXT_DIST = 'Flare Distance'

-- Returns the description displayed in the Scripts window
function script_description()
  return [[Lens Flare #2]]
end

function script_load(settings)
  obs.obs_register_source(source_info)
end

source_info = {}
source_info.id = 'filter-lensflare2'
source_info.type = obs.OBS_SOURCE_TYPE_FILTER
source_info.output_flags = obs.OBS_SOURCE_VIDEO

source_info.get_name = function()
    return "Lens Flare #2"
end

source_info.create = function(settings, source)

    local filter = {}
    filter.source = source
	filter.width = 1
	filter.height = 1

    obs.obs_enter_graphics()
    local effect_path = script_path() .. 'filter-lensflare2/filter-lensflare2.effect'
    filter.effect = obs.gs_effect_create_from_file(effect_path, nil)
    obs.obs_leave_graphics()

    if filter.effect == nil then
        source_info.destroy(filter)
        return nil
    end

    filter.params = {}
        filter.params.hair = obs.gs_effect_get_param_by_name(filter.effect, 'hair')
        filter.params.centerx = obs.gs_effect_get_param_by_name(filter.effect, 'centerx')
        filter.params.centery = obs.gs_effect_get_param_by_name(filter.effect, 'centery')
        filter.params.amount = obs.gs_effect_get_param_by_name(filter.effect, 'amount')
        filter.params.complex = obs.gs_effect_get_param_by_name(filter.effect, 'complex')
        filter.params.zoom = obs.gs_effect_get_param_by_name(filter.effect, 'zoom')
        filter.params.scatter = obs.gs_effect_get_param_by_name(filter.effect, 'scatter')
        filter.params.affect = obs.gs_effect_get_param_by_name(filter.effect, 'affect')
        filter.params.thresh = obs.gs_effect_get_param_by_name(filter.effect, 'thresh')
        filter.params.dist = obs.gs_effect_get_param_by_name(filter.effect, 'dist')
        filter.params.width = obs.gs_effect_get_param_by_name(filter.effect, 'width')
        filter.params.height = obs.gs_effect_get_param_by_name(filter.effect, 'height')
		--filter.params.time = obs.gs_effect_get_param_by_name(filter.effect, 'time')

    source_info.update(filter, settings)
    return filter
end

source_info.destroy = function(filter)
    if filter.effect ~= nil then
        obs.obs_enter_graphics()
        obs.gs_effect_destroy(filter.effect)
		filter.effect = nil
        obs.obs_leave_graphics()
    end
end

source_info.get_width = function(filter)
    return filter.width
end

source_info.get_height = function(filter)
    return filter.height
end

source_info.get_properties = function(settings)
    props = obs.obs_properties_create()

    obs.obs_properties_add_bool(props, SETTING_HAIR, TEXT_HAIR)
    obs.obs_properties_add_float_slider(props, SETTING_CENTERX, TEXT_CENTERX, -1.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_CENTERY, TEXT_CENTERY, -1.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_AMOUNT, TEXT_AMOUNT, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_COMPLEX, TEXT_COMPLEX, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_DIST, TEXT_DIST, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_ZOOM, TEXT_ZOOM, 0.0, 1.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_SCATTER, TEXT_SCATTER, 0.0, 1.0, 0.001)
    obs.obs_properties_add_bool(props, SETTING_AFFECT, TEXT_AFFECT)
    obs.obs_properties_add_float_slider(props, SETTING_THRESH, TEXT_THRESH, 0.0, 1.0, 0.001)

    return props
end

source_info.get_defaults = function(settings)
    obs.obs_data_set_default_double(settings, SETTING_CENTERX, -0.375)
    obs.obs_data_set_default_double(settings, SETTING_CENTERY, 0.25)
    obs.obs_data_set_default_double(settings, SETTING_AMOUNT, 2.0)
    obs.obs_data_set_default_double(settings, SETTING_COMPLEX, 1.0)
    obs.obs_data_set_default_double(settings, SETTING_ZOOM, 1.0)
    obs.obs_data_set_default_double(settings, SETTING_SCATTER, 1.0)
    obs.obs_data_set_default_bool(settings, SETTING_AFFECT, false)
    obs.obs_data_set_default_double(settings, SETTING_THRESH, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_DIST, 1.0)
    obs.obs_data_set_default_bool(settings, SETTING_HAIR, false)
end

source_info.update = function(filter, settings)
    filter.centerx = obs.obs_data_get_double(settings, SETTING_CENTERX)
    filter.centery = obs.obs_data_get_double(settings, SETTING_CENTERY)
    filter.amount = obs.obs_data_get_double(settings, SETTING_AMOUNT)
    filter.complex = obs.obs_data_get_double(settings, SETTING_COMPLEX)
    filter.zoom = obs.obs_data_get_double(settings, SETTING_ZOOM)
    filter.scatter = obs.obs_data_get_double(settings, SETTING_SCATTER)
    filter.affect = obs.obs_data_get_bool(settings, SETTING_AFFECT)
    filter.thresh = obs.obs_data_get_double(settings, SETTING_THRESH)
    filter.dist = obs.obs_data_get_double(settings, SETTING_DIST)
    filter.hair = obs.obs_data_get_bool(settings, SETTING_HAIR)

end

source_info.video_render = function(filter)

  local parent = obs.obs_filter_get_parent(filter.source)
  filter.width = obs.obs_source_get_base_width(parent)
  filter.height = obs.obs_source_get_base_height(parent)
  --filter.time = os.clock()

    obs.obs_source_process_filter_begin(filter.source, obs.GS_RGBA, obs.OBS_NO_DIRECT_RENDERING)

    obs.gs_effect_set_bool(filter.params.hair, filter.hair)
    obs.gs_effect_set_float(filter.params.centerx, filter.centerx)
    obs.gs_effect_set_float(filter.params.centery, filter.centery)
    obs.gs_effect_set_float(filter.params.amount, filter.amount)
    obs.gs_effect_set_float(filter.params.complex, filter.complex)
    obs.gs_effect_set_float(filter.params.zoom, filter.zoom)
    obs.gs_effect_set_float(filter.params.scatter, filter.scatter)
    obs.gs_effect_set_bool(filter.params.affect, filter.affect)
    obs.gs_effect_set_float(filter.params.thresh, filter.thresh)
    obs.gs_effect_set_float(filter.params.dist, filter.dist)
	obs.gs_effect_set_int(filter.params.width, filter.width)
	obs.gs_effect_set_int(filter.params.height, filter.height)
    --obs.gs_effect_set_float(filter.params.time, filter.time)

    obs.obs_source_process_filter_end(filter.source, filter.effect, filter.width, filter.height)
end
